; *******************************************************
; *     CRT Interface Unit                              *
; *******************************************************

        TITLE   CRT

        INCLUDE SE.ASM

.8086

CODE    SEGMENT BYTE PUBLIC

        ASSUME  CS:CODE

; Publics
        PUBLIC  Sound,NoSound
        PUBLIC  YesSound

; Start sound generator
Sound:  MOV     BX,SP
        MOV     BX,SS:[BX+4]
        MOV     AX,34DDH
        MOV     DX,0012H
        CMP     DX,BX
        JNC     @@2
        DIV     BX
        MOV     BX,AX
        IN      AL,61H
        TEST    AL,3
        JNZ     @@1
        OR      AL,3
        OUT     61H,AL
        MOV     AL,0B6H
        OUT     43H,AL
@@1:    MOV     AL,BL
        OUT     42H,AL
        MOV     AL,BH
        OUT     42H,AL
@@2:    RETF    2

; Turn off sound generator
NoSound:IN      AL,61H
        AND     AL,0FCH
SndEnd: OUT     61H,AL
        RETF

; Turn on sound generator
YesSound:
        in al, 61h
        or al, 3
        jmp short SndEnd

CODE    ENDS

        END
