
(*
Huomioitavaa:
  Ennen kntmist tee alla
  olevan mallin mukaisesti:

 Options Window  Help  [] Startup options ͻ
 Ŀ                                         
  Compiler...             [ ] Dual monitor support           
  Memory sizes...         [ ] Graphics screen save           
  Linker...               [ ] EGA/VGA palette save           
  Debugger...             [ ] CGA snow checking              
  Directories...          [ ] LCD color set                  
  Browser...              [ ] Load .TPL file                 
  Tools...              [X] Preserve symbols               
 Ĵ        [ ] Return to last dir             
 Environment  >                                            
  Ŀ      Swap file size            0      K  
   Preferences...                                           
   Editor...            Swap file directory                 
   Mouse...              c:\                                
  Startup...                                              
    Colors...                 OK       Cancel      Help   
                     
                         ͼ

*)

{ $DEFINE NOSOUNDS}
{ $DEFINE NOMUSIC}
{ $DEFINE NOTEXT}

{$M 3072,440000,655360}

Uses
  Objects, Strings, Crt, KBD, SetJmp, MMem,
  Midas, mplayer, modp, sdevice, Errors;

Type
  pHandle = Word;

Const
  BackGroundColor = 255;
  HC: Array[0..15]Of Char = '0123456789ABCDEF';

Var
  FlipPic: Boolean;
  VGAPal: Array[0..767]Of Byte;

Type
  PPResItem = ^TPResItem;
  PResItem = ^TResItem;
  TPResItem = Array[0..16382]Of PResItem;
  TResItem = Object
    x,y: Integer;
    xs,ys: Word;
    Data: Record End;
    Procedure View(Flip: Boolean; sx,sy: Integer);
  End;

  PView = ^TView;
  PGraph = ^TGraph;
  TGraph = Object(TObject)
    ScreenX, ScreenY: Integer;
    DrawRed: Boolean;
    Constructor Init;
    Function Point(x, y: Integer): Byte;
    Procedure Put(x, y: Integer; Var Src; xs, ys: Byte);
    Destructor Done; Virtual;

    Procedure ScreenRight;
    Procedure RelocateScreen;

    Function Visible(p: PView): Boolean;
  End;

  PResource = ^TResource;
  TResource = Object(TResItem)
    MaxRes: Word;
    Used: Word;
    Resources: PPResItem;
    Constructor Init(AMaxRes: Word);

    Function Insert(ax,ay: Integer; sx,sy: Word): pHandle;
    Function GetItem(Handle: pHandle): PResItem;

    Procedure FreeItem(Handle: pHandle);

    Procedure Draw(Handle: pHandle; ax,ay: Integer; Flip: Boolean);

    Destructor Done;
  End;

  LeftRight = (Left,Right, None, DirNotExist);
  UpDown = (Up,Down, Mid);

  PWorld = ^TWorld;
  TView = Object(TObject)
    Owner: PWorld;
    Frame: pHandle;
    x,y: Integer;
    EndUp: Boolean;
    AllocFlag: Integer;
    Dir: LeftRight;
    Power: Integer;

    Constructor Init(ax,ay: Integer; NewDir: LeftRight);

    Function Maata: Boolean;
    Function Kattoa: Boolean;
    Function Sivulla(Kumpi: LeftRight): Boolean;

    Procedure Crash; Virtual;

    Function GetFrame: pHandle; Virtual;
    Procedure Control; Virtual;
    Procedure Show; Virtual;
    Destructor Done; Virtual;

    Procedure IncBlink(HowMuch: Integer); Virtual;

    Procedure Lock;
    Procedure UnLock;

    Procedure Reset; Virtual;

    Procedure Suffer(Lot: Integer); Virtual;
    Procedure HitFrom(Kuka: PView); Virtual;

  Private
    Prev, Next: PView;
  Private
    Blink: Integer;
    OriginalX, OriginalY: Integer;
    OriginalFrame, OriginalDir: LeftRight;
  End;

  PFlyBoy = ^TFlyBoy;
  TFlyBoy = Object(TView)
    Kohti: PView;
    Pysty: UpDown;

    Counter: Integer;

    Constructor Init(ax,ay: Integer);
    Procedure HitFrom(Kuka: PView); Virtual;
    Procedure Control; Virtual;
    Procedure Reset; Virtual;
  Private
    Procedure UusiKohde;
  End;

  PExaMan = ^TExaMan;
  TExaMan = Object(TView)
    Mode: (mStand,mWalk,mJump);
    Idle, UpGo, Counter: Integer;
    Shooting: Integer;

    Constructor Init(ax,ay: Integer);

    Procedure Suffer(Lot: Integer); Virtual;
    Procedure HitFrom(Kuka: PView); Virtual;

    Procedure Control; Virtual;
    Procedure Update;
    Function GetFrame: pHandle; Virtual;
    Procedure Reset; Virtual;

  Private
    Procedure Jump;
    Procedure Walk(NewDir: LeftRight);
  End;

  TWorld = Object(TObject)
    Items: PView;
    Constructor Init;
    Function FindFirst(Typi: Pointer): PView;
    Function Find(Typi: Pointer): PView;
    Function FindAny: PView;
    Function Insert(Item: PView): PView;
    Procedure Show;
    Procedure Report(m: PView);
    Procedure Update;
    Procedure View;
    Destructor Done; Virtual;
    Procedure IncBlink(HowMuch: Integer); Virtual;
  End;

Const
  BlinkBit = 4;

Var
  Kuvat: PResource;
  World: PWorld;
  Graph: PGraph;

  ErrorExit: JmpBuf;

Var
  fxChannel: Integer;
  SD: PSoundDevice;

  SB, MB, FB, Result: PChar;

  hWalk00, hWalk01, hWalk02,
  hJump00,
  hPop00, hPop01, hPop02,

  hTile00, hTile01,
  hTile03, hTile04,

  hTile05a,hTile05b,hTile05c,hTile05d,
  hTile05e,hTile05f,hTile05g,hTile05h,
  hTile05i,hTile05j,hTile05k,

  oFlyBoy00, oFlyBoy01,
  hUfo00,

  gWalk00, gWalk01, gWalk02,
  gJump00
  : pHandle;

  eKZup00
  : Word;

  SoundError: Integer;

{$IFNDEF NOMUSIC}
Const
  Module: PmpModule = Nil;           { current playing module }
{$ENDIF}

Var
  ItsMe: PView;

Function OutOfMemory(Size: Word): Integer; Far;
Var
  w: Word;
  Ch: Char;
{$IFNDEF NOMUSIC}
  TryMod: Boolean;
{$ENDIF}
Label P1;
Begin
  If Size=0 Then
    OutOfMemory := 2
  Else
  Begin
{$IFNDEF NOMUSIC}
    TryMod := Module <> Nil;
{$ENDIF}
    TextMode(CO80);
    Write(
      'Can''t allocate ',Size,' bytes of memory.'^M^J+
      'There is ',MemAvail,' bytes available');
    If MaxAvail <> MemAvail Then
      Write(', but the biggest block that'^M^J+
        'can be allocated at this time is "only" ',MaxAvail,' bytes long');

{$IFNDEF NOMUSIC}
    If Module <> Nil Then
    Begin
      midasStopModule(module);
      midasFreeModule(module);
    {  module := midasLoadModule('d:/mod/tcsmods/exaerror.mod',
        PModulePlayer(@mpMOD), NIL);
      midasPlayModule(module, 0)}
    End;
{$ENDIF}

    Asm
      mov ax, ss:[bp+12]; mov ErrAddr.word[0], ax
      mov ax, ss:[bp+14]; mov ErrAddr.word[2], ax
    End;

    Write('.'^M^J^J+
      'What shall we do now?'^M^J);

{$IFNDEF NOMUSIC}
    If TryMod Then Write(
      #9'1: Try to continue without music'^M^J);
{$ENDIF}
    Write(
      #9'9: Produce error'^M^J+
      '    other: Return to DOS'^M^J);

    Ch := UpCase(ReadKey);
    Write(#13);

{$IFNDEF NOMUSIC}
    {If module <> Nil Then
    Begin
      midasStopModule(module);
      midasFreeModule(module);
    }  module := Nil;
    {End;}
{$ENDIF}

    Case Ch Of
{$IFNDEF NOMUSIC}
      '1':
      Begin
        If Not TryMod Then Goto P1;
        OutOfMemory := 2;
        ErrAddr := Nil;
        ExitCode := 0;
        Exit;
      End;
{$ENDIF}
      '9': ExitCode := 203;
      Else
P1:     Write(#10'Ok'^M^J);
        ErrAddr := Nil
    End;

    LJmp(ErrorExit, 1)
  End
End;

Function LoadEffect(fileName: PChar; looping: integer): word;
Var
  instHandle: word;                  { Sound Device instrument handle }
  error: integer;
  smpLength: longint;                { sample length }
  smpBuf: ^byte;                     { sample loading buffer }
  f: File;
Begin
  If SoundError <> 0 Then Exit;
  Assign(f, FileName);
  Reset(f, 1);
  smpLength := FileSize(f);

  GetMem(SmpBuf, smpLength);

  BlockRead(f, SmpBuf^, smpLength);

  Close(f);

  If looping = 1 Then
    Error := SD^.AddInstrument(smpBuf, smp8bit, smpLength, 0, smpLength,
      64, 1, 1, @instHandle)
  Else
    Error := SD^.AddInstrument(smpBuf, smp8bit, smpLength, 0, 0,
      64, 0, 1, @instHandle);

  If error <> 0 Then midasError(error);

  FreeMem(SmpBuf, smpLength);

  LoadEffect := instHandle
end;

procedure FreeEffect(instHandle : word);
var
  error : integer;
begin
  If SoundError <> 0 Then Exit;
  { remove instrument from Sound Device list: }
  error := SD^.RemInstrument(instHandle);
  if error <> 0 then midasError(error)
end;

procedure PlayEffect(instHandle: word; rate: longint; volume: word;
  panning: integer);
var
  error : integer;
begin
  If(instHandle = 32767)
  Or(SoundError <> 0)Then Exit;

  { set effect instrument to current effect channel: }
  error := SD^.SetInstrument(fxChannel, instHandle);
  if error <> 0 then midasError(error);

  { set effect volume: }
  error := SD^.SetVolume(fxChannel, volume);
  if error <> 0 then midasError(error);

  { set effect panning: }
  error := SD^.SetPanning(fxChannel, panning);
  if error <> 0 then midasError(error);

  { start playing effect: }
  error := SD^.PlaySound(fxChannel, rate);
  if error <> 0 then midasError(error);

  fxChannel := (fxChannel + 1)And 7
end;


{---- TVIEW ----}
Constructor TView.Init(ax,ay: Integer; NewDir: LeftRight);
Begin
  Power := 100;
  Owner := Nil;
  Dir := NewDir;
  OriginalDir := Dir;
  x := ax; OriginalX := x;
  y := ay; OriginalY := y;
  Frame := 65535;
  EndUp := False;
  AllocFlag := 0;
  Blink := 0;
End;

Procedure TView.IncBlink(HowMuch: Integer);
Begin
  Inc(Blink, HowMuch)
End;

Procedure TView.HitFrom(Kuka: PView);
Begin
  Suffer(101)
End;

Procedure TView.Suffer(Lot: Integer);
Label P1;
Begin
  If Lot=101 Then Goto P1;
  Dec(Power, Lot);
  If Power > 100 Then Power := 100;
  If Power < 0 Then
  Begin
P1: {Thn vliin voit list esimerkiksi jos hahmosta
     kuollessaan tulee joku esine}
    EndUp := True
  End
End;

Procedure TView.Lock; Begin Inc(AllocFlag)End;
Procedure TView.UnLock; Begin If AllocFlag > 0 Then Dec(AllocFlag)End;

Procedure TView.Reset;
Var rx, ry: Integer;
Begin
  If(x<>OriginalX)Or(y<>OriginalY)Then
  Begin
    rx := x;
    ry := y;
    x := OriginalX;
    y := OriginalY;
    If Graph^.Visible(@Self)Then
    Begin
      x := rx;
      y := ry
    End
  End;

  Dir := OriginalDir;
  Frame := 65535;
  Blink := 0
End;

Procedure TView.Show;
Begin
  If Blink And BlinkBit <> 0 Then Graph^.DrawRed := True;
  Kuvat^.Draw(GetFrame, x, y, Dir=Left);
  Graph^.DrawRed := False;
End;

Procedure TView.Crash;
Begin
  Dir := None
End;

Function TView.GetFrame: pHandle;
Begin
  GetFrame := Frame
End;

Procedure TView.Control;
Begin
  If EndUp Then Exit;

  If Dir <> None Then
    If Not Sivulla(Dir)Then
    Begin
      If Dir=Left
        Then Dec(x)
        Else Inc(x)
    End
    Else
      Crash
End;

Function TView.Maata: Boolean;
Var a: Integer;
Begin
  Maata := True;

  For a := Kuvat^.GetItem(GetFrame)^.xs-1 DownTo 0 Do
    If Graph^.Point(x+a, y) <> BackGroundColor Then
      Exit;

  Maata := False
End;

Function TView.Kattoa: Boolean;
Var a, b: Integer;
Begin
  Kattoa := True;

  b := Kuvat^.GetItem(GetFrame)^.ys;
  For a := Kuvat^.GetItem(GetFrame)^.xs-1 DownTo 0 Do
    If Graph^.Point(x+a, y-b-1) <> BackGroundColor Then
      Exit;

  Kattoa := False
End;

Function TView.Sivulla(Kumpi: LeftRight): Boolean;
Var a, b: Integer;
Begin
  Sivulla := True;

  If Kumpi = Left
    Then b := -1
    Else b := Kuvat^.GetItem(GetFrame)^.xs;

  For a := Kuvat^.GetItem(GetFrame)^.ys-1 DownTo 1 Do
    If Graph^.Point(x+b, y-a) <> BackGroundColor Then
      Exit;

  Sivulla := False
End;

Destructor TView.Done;
Begin
  If Prev <> Nil Then Prev^.Next := Next;
  If Next <> Nil Then Next^.Prev := Prev;
  Inherited Done;
End;

{---- TFLYBOY ----}
Constructor TFlyBoy.Init(ax, ay: Integer);
Begin
  Inherited Init(ax,ay, None);
  Frame := oFlyBoy00;

  If Dir<>None Then
    If Sivulla(Dir)Then
      Fail;

  Pysty := Mid;
  Kohti := Nil;

  UusiKohde
End;

Procedure TFlyBoy.Reset;
Begin
  Inherited Reset;
  Frame := oFlyBoy00;
  Pysty := Mid;
  Kohti := Nil;
  UusiKohde
End;

Procedure TFlyBoy.UusiKohde;
Begin
  If(Kohti <> Nil)And(Kohti <> @Self)Then Kohti^.UnLock;

  Kohti := World^.FindFirst(TypeOf(TExaMan)); {NIT JAHDATAAN!!!}
  If Kohti = Nil Then Kohti := World^.FindAny;
  If Kohti = Nil Then Kohti := @Self
End;

Procedure TFlyBoy.Control;
Begin
  If EndUp Then Exit;

  Case Random(1000)Of
    0: Dir := Left;
    1: Dir := Right;
    2: Pysty := Up;
    3: Pysty := Down;
    4: Dir := None;
    5: Pysty := Mid;
    50..75:
      If Kohti^.x < x Then Dir := Left
      Else If Kohti^.x > x Then Dir := Right
      Else Dir := None;

    176..199:
      If(Kohti^.y < y)Then Pysty := Up
      Else If(Kohti^.y > y)Then Pysty := Down;
    500..549: Frame := oFlyBoy00;
    550..599: Frame := oFlyBoy01;
    800..999: UusiKohde;
  End;

  If Kohti <> @Self Then
    If Kohti^.EndUp Then
      UusiKohde;

  If(Pysty = Up)And Not Kattoa Then Dec(y);
  If(Pysty =Down)And Not Maata Then Inc(y);

  Inc(Counter);
  If Counter And 1 <> 1 Then
  Begin
    If Dir <> None Then
      If Not Sivulla(Dir)Then
      Begin
        If Dir=Left
          Then Dec(x)
          Else Inc(x)
      End;
    Counter := 0
  End
End;

Procedure TFlyBoy.HitFrom(Kuka: PView);
Begin
  If TypeOf(Kuka^) = TypeOf(TFlyBoy)Then
  Begin
    If Dir=Left Then Dir := Right
    Else If Dir=Right Then Dir := Left;

    If Pysty=Down Then Pysty := Up
    Else If Pysty=Up Then Pysty := Down;

    If Sivulla(Left)Then Dir := Right
    Else If Sivulla(Right)Then Dir := Left
  End;
{
  Tss esimerkki Exa Man -pelist miten voi mrt
  hahmon voimat ja kosketukset toisiinsa

  If(TypeOf(Kuka^) = TypeOf(TSleepyTurtle))
  Or(TypeOf(Kuka^) = TypeOf(TPati))Then
    Suffer(101)
}
End;

{---- TEXAMAN ----}
Constructor TExaMan.Init(ax,ay: Integer);
Begin
  Inherited Init(ax,ay, Right);
  Mode := mStand;
  Counter := 0;
  Frame := hJump00;
  Shooting := 0;
  Idle := 0;
End;

Procedure TExaMan.Suffer(Lot: Integer);
Begin
  Dec(Power, Lot);


  If Power > 100 Then Power := 100;

  If Power < 0 Then
  Begin
    Power := 0;
    Reset {For TExaMan this means: explode!!!}
  End;

  If Lot > 0 Then IncBlink(100)
End;

Procedure TExaMan.HitFrom(Kuka: PView);
Var p: Pointer;
Begin
  If Blink > 0 Then Exit;

  p := TypeOf(Kuka^);
  If p = TypeOf(tFlyBoy)Then Suffer(9);

  If EndUp And(ItsMe = @Self)Then ItsMe := Kuka
End;

Procedure TExaMan.Reset;
Begin
  EndUp := True
End;

Procedure TExaMan.Walk(NewDir: LeftRight);
Begin
  If(Mode=mStand)Or(Dir=NewDir)Or(Mode=mJump)Or(Counter = 0)Then
  Begin
    Dir := NewDir;
    If Mode = mJump Then
    Begin
      If Dir = Left
        Then Begin If Not Sivulla(Left)Then Dec(x)End
        Else Begin If Not Sivulla(Right)Then Inc(x)End
    End
    Else
    Begin
      Counter := 6;
      Mode := mWalk;
      Case Mem[Seg0040:$006C]And $06 Of
        $00: Frame := hWalk00;
        $02: Frame := hWalk02;
        $04: Frame := hWalk01;
        $06: Frame := hWalk02;
      End
    End
  End
End;

Procedure TExaMan.Jump;
Begin
  If((Mode = mJump)Or Maata)And Not Kattoa And(UpGo<>1)Then
  Begin
    If Maata Then
    Begin
      Mode := mJump;
      Frame := hJump00;
      Counter := 2;
      UpGo := 2;
    End;
    If(UpGo < 25)And(UpGo > 1)Then
    Begin
      Inc(Counter); UpDate;
      Inc(Counter);
      Inc(UpGo)
    End
    Else
      UpGo := 1
  End
End;

Function TExaMan.GetFrame: pHandle;
Begin
  If Shooting <= 0 Then
    GetFrame := Inherited GetFrame
  Else
  Begin
    GetFrame := Inherited GetFrame;
    If(Frame = hWalk00)Then GetFrame := gWalk00;
    If(Frame = hWalk01)Then GetFrame := gWalk01;
    If(Frame = hWalk02)Then GetFrame := gWalk02;
    If(Frame = hJump00)Then GetFrame := gJump00;
  End
End;

Procedure TExaMan.Update;
Var
  a: Word;
  i: Integer Absolute a;
  k: Integer;
  Hmm: LeftRight;
Begin
  If Blink>0 Then Dec(Blink);

  If EndUp Then Exit;

  If Mode = mWalk Then
  Begin
    If Counter>0 Then Dec(Counter);
    If Not Sivulla(Dir)Then
      If Dir=Left
        Then Dec(x)
        Else Inc(x)
  End;

  If Mode = mWalk Then
  Begin
    If Counter < 5 Then Begin Frame := hJump00; End;
    If Counter = 0 Then Begin Mode := mStand End;
  End;
  If Mode = mJump Then
  Begin
    If Counter > 0 Then
      If Kattoa
        Then Counter := 0
        Else Dec(Counter);

    If Counter > 0 Then
    Begin
      For a := 1 DownTo 0 Do
        If Kattoa Then Counter := 0 Else Dec(y)
    End
    Else
      For a := 2 DownTo 0 Do
        If Maata Then
        Begin
          PlayEffect(eKZup00, 22025, 32, panMiddle);
          Mode := mStand
        End
        Else
          Inc(y);
  End;

  If Shooting > 0 Then
  Begin
    Dec(Shooting);
    If Shooting = 0 Then Idle := 0
  End;

  If(Mode <> mJump)And Not Maata Then
  Begin
    Mode := mJump;
    Frame := hJump00;
    If Maata Then
    Begin
      Frame := hJump00;
      Mode := mStand
    End;
    Counter := 0
  End;

  If(Mode = mWalk)And(Shooting > 0)
    Then Hmm := Right  {KvelyAmpuu}
    Else Hmm := Left;  {Kvelee muuten vain}

  While Sivulla(Dir)Do
    If Dir = Right
      Then Dec(x)
      Else Inc(x)
End;

Procedure TExaMan.Control;
Var
  b: Boolean;
Begin
  {If KBuf[$48]Or KBuf[$38]Or KBuf[$1E]Then Jump Else UpGo := 0;} {Alt,Up,A}

  Walk(Right);
  {If KBuf[$4B]Then Walk(Left); } {Left}
  {If KBuf[$4D]Then Walk(Right);} {Right}

  Inc(x, 4);
  b := Sivulla(Right);
  Dec(x, 4);
  If b Then Jump;

  If KBuf[$1D]Or KBuf[$53]Then {Ctrl,DEL}
  Begin
    If Shooting <= 5 Then
    Begin
      Shooting := 10;

      If Mode=mStand Then Update;
    End
  End;

  Update
End;

{---- TWORLD ----}
Constructor TWorld.Init;
Begin
  Inherited Init;
  Items := Nil
End;

Procedure TWorld.Show;
Var p: PView;
Begin
  p := Items;
  While p <> Nil Do
  Begin
    p^.Show;
    p := p^.Next
  End;
End;

Function TWorld.FindFirst(Typi: Pointer): PView;
Var p: PView;
Begin
  p := Items;
  FindFirst := Nil;
  While p <> Nil Do
  Begin
    If(TypeOf(p^) = Typi)And Not p^.EndUp Then
    Begin
      FindFirst := p;
      Exit
    End;
    p := p^.Next
  End;
End;

Function TWorld.Find(Typi: Pointer): PView;
Var
  p: PView;
  HowMany: Integer;
Begin
  p := Items;
  Find := Nil;
  HowMany := 1;
  While p <> Nil Do
  Begin
    If(TypeOf(p^) = Typi)And Not p^.EndUp Then Inc(HowMany);
    p := p^.Next
  End;
  If HowMany = 0 Then Exit;
  HowMany := Random(HowMany+1);

  p := Items;
  While p <> Nil Do
  Begin
    If(TypeOf(p^) = Typi)And Not p^.EndUp Then
    Begin
      Dec(HowMany);
      If HowMany = 0 Then
      Begin
        Find := p;
        Exit
      End
    End;
    p := p^.Next
  End;
End;

Function TWorld.FindAny: PView;
Var
  p: PView;
  HowMany: Integer;
Begin
  p := Items;
  FindAny := Nil;
  HowMany := 1;
  While p <> Nil Do
  Begin
    If Not p^.EndUp Then Inc(HowMany);
    p := p^.Next
  End;
  If HowMany = 0 Then Exit;
  HowMany := Random(HowMany+1);

  p := Items;
  While p <> Nil Do
  Begin
    If Not p^.EndUp Then
    Begin
      Dec(HowMany);
      If HowMany = 0 Then
      Begin
        FindAny := p;
        Exit
      End
    End;
    p := p^.Next
  End
End;

Procedure TWorld.IncBlink(HowMuch: Integer);
Var p: PView;
Begin
  p := Items;
  While p <> Nil Do
  Begin
    p^.IncBlink(HowMuch);
    p := p^.Next
  End
End;

Procedure TWorld.Update;
Var
  l, p: PView;
Begin
  p := Items;
  While p <> Nil Do
  Begin
    If Graph^.Visible(p)Then
    Begin
      p^.Control;
      If Not p^.EndUp Then p^.Show;
      Report(p)
    End
    Else
      p^.Reset;

    If p^.y > 199 Then
    Begin
      If TypeOf(p^) = TypeOf(TExaMan)Then PExaMan(p)^.Power := 0;
      p^.EndUp := True;
      If p = ItsMe Then
      Begin
        ItsMe := World^.Items;
        If ItsMe = p Then ItsMe := ItsMe^.Next
      End
    End;

    l := p^.Next;

    If(p^.EndUp)And(p^.AllocFlag = 0)Then
    Begin
      If p=Items Then
        If p^.Next <> Nil
          Then Items := p^.Next
          Else Items := p^.Prev;

      Dispose(p, Done);
    End;

    p := l
  End
End;

Procedure TWorld.View;
Var
  l, p: PView;
Begin
  p := Items;
  While p <> Nil Do
  Begin
    If Graph^.Visible(p)Then
      If Not p^.EndUp Then p^.Show;

    l := p^.Next;

    If(p^.EndUp)And(p^.AllocFlag = 0)Then
    Begin
      If p=Items Then
        If p^.Next <> Nil
          Then Items := p^.Next
          Else Items := p^.Prev;

      Dispose(p, Done)
    End;

    p := l
  End
End;

Function TWorld.Insert(Item: PView): PView;
Begin
  Insert := Item;
  If Item=Nil Then Exit;
  Item^.Owner := @Self;
  Items^.Prev := Item;
  Item^.Next := Items;
  Item^.Prev := Nil;
  Items := Item;
End;

Destructor TWorld.Done;
Var p: PView;
Begin
  While Items <> Nil Do
  Begin
    p := Items^.Next;
    Dispose(Items, Done);
    Items := p
  End;
  Inherited Done;
End;

Function Sisaltaa(a, b: TPoint): Boolean;
Begin
  Sisaltaa :=
    (A.X >= B.X)And(A.X <= B.Y)
  Or(A.Y >= B.X)And(A.Y <= B.Y)
  Or(B.X >= A.X)And(B.X <= A.Y)
  Or(B.Y >= A.X)And(B.Y <= A.Y)
End;

Procedure TWorld.Report(m: PView);
Var
  p: PView;
  x1,y1, x2,y2: TPoint;
  q: PResItem;
Begin
  p := Items;

  While p <> Nil Do
  Begin
    If(p <> m)And Not p^.EndUp And(Graph^.Visible(p))Then
    Begin
      With p^ Do
      Begin
        q := Kuvat^.GetItem(GetFrame);
        If q=Nil Then Continue;
        x1.x := x; x1.y := x + q^.xs;
        y1.y := y; y1.x := y - q^.ys;
      End;

      With m^ Do
      Begin
        q := Kuvat^.GetItem(GetFrame);
        If q=Nil Then Continue;
        x2.x := x; x2.y := x + q^.xs;
        y2.y := y; y2.x := y - q^.ys;
      End;

      If Sisaltaa(x1,x2)And Sisaltaa(y1,y2)Then
      Begin
        p^.HitFrom(m); If p^.EndUp And(ItsMe = p)Then ItsMe := m;
        m^.HitFrom(p); If m^.EndUp And(ItsMe = m)Then ItsMe := p;
      End
    End;

    p := p^.Next
  End;
End;

{---- TRESOURCE ----}
Constructor TResource.Init(AMaxRes: Word);
Begin
  MaxRes := AMaxRes;
  If MaxRes > 65520 Div 4 Then MaxRes := 65520 Div 4;

  Used := 0;

  GetMem(Resources, MaxRes*4);

  FillChar(Resources^, MaxRes*4, 0);

  x := -1;
  y := -1;
  xs := 0;
  ys := 0
End;

Function TResource.Insert(ax,ay: Integer; sx,sy: Word): Word;
Var
  a, b: Word;
  p: PChar;
Begin
  While Resources^[Used] <> Nil Do
  Begin
    Inc(Used);
    If Used >= MaxRes Then RunError(203)
  End;

  If Used >= MaxRes Then RunError(203);

  GetMem(Resources^[Used], SizeOf(TResItem)+sx*sy);
  If Resources^[Used] = Nil Then RunError(203);

  Resources^[Used]^.x :=ax;
  Resources^[Used]^.y :=ay;
  Resources^[Used]^.xs:=sx;
  Resources^[Used]^.ys:=sy;

  p := PChar(@Resources^[Used]^.Data);
  For b := sy-1 DownTo 0 Do
    For a := sx-1 DownTo 0 Do
      p[b * sx + a] := Chr(Graph^.Point(ax+a, ay+b));

  Insert := Used;

  Inc(Used)
End;

Procedure TResource.FreeItem(Handle: pHandle);
Var w: Word;
Begin
  If Resources^[Handle] = Nil Then Exit;

  w := Word(Resources^[Handle]^.x) * Word(Resources^[Handle]^.y);
  FreeMem(Resources^[Handle], w+SizeOf(TResItem));
  Resources^[Handle] := Nil;
  Used := Handle
End;

Destructor TResource.Done;
Var Handle: Word;
Begin
  For Handle := MaxRes Div 4 - 1 DownTo 0 Do
    If Resources^[Handle] <> Nil Then
      FreeItem(Handle)
End;

Function TResource.GetItem(Handle: pHandle): PResItem;
Begin
  GetItem := @Self;
  If Handle >= Used Then Exit;

  GetItem := Resources^[Handle];
End;

Procedure TResource.Draw(Handle: pHandle; ax,ay: Integer; Flip: Boolean);
Begin
  If Handle=32767 Then Exit;
  GetItem(Handle)^.View(Flip, ax, ay)
End;

Procedure TResItem.View(Flip: Boolean; sx,sy: Integer);
Begin
  FlipPic := Flip;
  Graph^.Put(sx,sy-ys, Data, xs,ys);
  FlipPic := False
End;

Procedure MapRow(MapX, ScreenX: Word); Forward;


{---- TGraph ----}
Procedure DrawSprite(Dest: PChar; Var Src;
                     x, y: Word; Flip: Boolean;
                     PictXSize, PictYSize: Word); Near; External;
Procedure SetMode; Near; External;
Procedure DrawScreen; Near; External;
Procedure UpdateScreen; Near; External;
Procedure Tekstit; Near; External;
{$L ENGINE.OBJ}


Constructor TGraph.Init;
Begin
  Inherited Init;

  DrawRed := False;

  ScreenX := 0;

  SetMode
End;

Procedure TGraph.Put(x, y: Integer; Var Src; xs, ys: Byte);
Begin
  If Not DrawRed
    Then DrawSprite(MB, Src, x-ScreenX,y, FlipPic, xs,ys);
End;

Function TGraph.Visible(p: PView): Boolean;
Begin
  Visible :=
     (p^.x+20 <= ScreenX+320)
  And(p^.x >= ScreenX)
End;

Function TGraph.Point(x, y: Integer): Byte;
Begin
  Point := Ord(FB[Word(y)*320 + Word(x-ScreenX)])
End;

Destructor TGraph.Done;
Begin
  TextMode(CO80);
  Inherited Done
End;

{Scrolls the screen right one pixel}
Procedure TGraph.ScreenRight;
Begin
  Move(FB[1], FB[0], 63999);
  MapRow((ScreenX+304)Mod(85*16)+16, 319);

  If ScreenX And 1 = 0 Then
    Asm
      les si, SB
      mov bx, 200
  @0:  mov cx, 319
       mov ah, es:[si]
  @1:  mov al, es:[si+1]
       mov es:[si], al
       inc si
       dec cx
       jnz @1
       mov es:[si], ah
       inc si
      dec bx
      jnz @0
    End;

  Inc(ScreenX);
End;

{Corrects the position of camera}
Procedure TGraph.RelocateScreen;
Var
  x: Integer;
Begin
  x := ItsMe^.x - 320 Div 2;

  If x>ScreenX Then ScreenRight
End;

Procedure LoadPCX(Name, Dest: PChar);
Var
  f: File;
  c, a, b, n: Byte;
  p: PChar;
  w: Word Absolute p;
Begin
  FileMode := 0;

  Assign(f, Name);
  Reset(f, 1);

  p := Dest;

  Seek(f, 128);
  Repeat
    BlockRead(f, a, 1);

    If a >= $C0 Then
    Begin
      b := a - $C0;

      BlockRead(f, a, 1);

      For n := 1 To b Do
      Begin
        p^ := Chr(a);
        Inc(p)
      End
    End
    Else
    Begin
      p^ := Chr(a);
      Inc(p)
    End
  Until p >= Dest+64000;
  Seek(f, FileSize(f) - 768);
  BlockRead(f, VGAPal, SizeOf(VGAPal));
End;

Procedure DrawBack;
Const FirstTime: Boolean = True;
Var
  w: Word;
Begin
  If FirstTime Then
  Begin
    LoadPCX('exaback1.pcx', SB);
    FirstTime := False
  End;
End;

Procedure DrawGame;
Begin
  FillChar(MB^, 64000, 255);
  World^.Update;
End;

Procedure DrawFore;
Begin
  Graph^.RelocateScreen;
End;

Procedure DoText;
Const
  FirstTime: Boolean = True;
  PixPos: Word = 0;
  Font: PChar = Nil;
  Length: Integer = 0;
  p: PChar = Nil;
Var
  t: PChar;
  a, Start, x, y: Integer;
  b: Byte;
Begin
  If FirstTime Then
  Begin
    p := PChar(@Tekstit);
    Asm
      push bp
       mov ax, 1130h
       mov bh, 6
       int 10h
       mov ax, bp
      pop bp
      mov Font.word[0], ax
      mov Font.word[2], es
    End;
    FirstTime := False
  End
  {$IFDEF NOTEXT}Else Exit{$ENDIF};

  If p[1] = #0 Then p := PChar(@Tekstit);

  If PixPos And 63 = 63 Then
  Begin
    While p^ <> #10 Do Inc(p);
    Inc(p);
    t := p; Length := 0;
    While t^ <> #10 Do Begin Inc(Length); Inc(t)End
  End;

  Inc(PixPos);

  If PixPos And 63 < 48 Then
    For y := 0 To 15 Do
    Begin
      Start := 160 - Length*4;
      For x := 0 To Length*8-1 Do
      Begin
        a := Word(p[x Shr 3])Shl 4;
        b := (Ord(Font[a+y])Shl(x And 7))And 128;
        If b<>0 Then
        Begin
          Result[(Word(50+y)*320)+Start] := Chr(64 + y);
          Inc(Start);
          Result[(Word(50+y)*320)+Start] := Chr(69 + y*3 Div 4)
        End
        Else
          Inc(Start)
      End
    End
End;

Procedure RunStep;
Var x, y: Word;
Begin
  DrawBack;
  DrawGame;
  DrawFore;
  DrawScreen;

  If TypeOf(ItsMe^) = TypeOf(TExaMan)Then
    For y := 0 To 50 Do
      For x := 0 To 9 Do
      Begin
        Result[970+x+y*640] := #0;
        If y<>50 Then
          If(PExaMan(ItsMe)^.Power <= 100-y*2)Or(x=0)Or(x=9)
            Then Result[1290+x+y*640] := #0
            Else Result[1290+x+y*640] := #15
      End
  Else If(ItsMe = Nil)Or(Random(25)=0)Then
    ItsMe := World^.FindAny;

  DoText
End;

{---- MAP MANAGER ----}
Const
  Map: Array[0..12, 0..90]Of Char =
 ('       OUUR                                                    OUUUUUUUUUUUUUR        ',
  '  f                 G                                                     f           ',
  '                    G                                                                 ',
  '                    G  f                        f                                     ',
  '                    GGGGGGGGGGG                                                       ',
  '                                                                                 f    ',
  '                                                                                      ',
  '                                                                                      ',
  '                 LTTTTTTTTTM                 GGG               AAAAA                  ',
  '                 KUUUUUUUUUN                                   AAAAA                  ',
  'M    e           K     f   N                                   AAAAA                  ',
  'QTTTTTTTTTTTTTTTTP         QM        LTTTTTTTTTTTTTTTTTTTTAAAAAAAAAAAAAAAAAAATTTTM   L',
  'SSSSSSSSSSSSSSSSSS         SQTTTTTTTTPSSSSSSSSSSSSSSSSSSSAAAAAAAAAAAAAAAAAAAAAASSQM LP');

Procedure PSet(x, y: Word; c: Byte); Assembler;
Asm
  mov cl, byte ptr x
  and cl, 3
  mov ax, 0102h
  shl ah, cl
  mov dx, 3C4h
  out dx, ax

  mov ax, 320/4
  mul y
  mov bx, x
  shr bx, 2
  add bx, ax
  mov es, SegA000
  mov al, c
  mov es:[bx], al
End;

Procedure MapRow(MapX, ScreenX: Word);
Var
  y: Integer;
  h: pHandle;
  ScreenY: Integer;
  p: PChar;
  w: Word;
Begin
  If MapX Shr 4 > High(Map[0])Then MapX := High(Map[0])Shl 4;

  For y := 0 To 199 Do
  Begin
    p := Nil;

    Case Map[Word(y)Shr 4, Word(MapX)Shr 4]Of
      'A': p := PChar(@Kuvat^.GetItem(hTile00 )^.Data);
      'G': p := PChar(@Kuvat^.GetItem(hTile03 )^.Data);
      'K': p := PChar(@Kuvat^.GetItem(hTile05a)^.Data);
      'L': p := PChar(@Kuvat^.GetItem(hTile05b)^.Data);
      'M': p := PChar(@Kuvat^.GetItem(hTile05c)^.Data);
      'N': p := PChar(@Kuvat^.GetItem(hTile05d)^.Data);
      'O': p := PChar(@Kuvat^.GetItem(hTile05e)^.Data);
      'P': p := PChar(@Kuvat^.GetItem(hTile05f)^.Data);
      'Q': p := PChar(@Kuvat^.GetItem(hTile05g)^.Data);
      'R': p := PChar(@Kuvat^.GetItem(hTile05h)^.Data);
      'S': p := PChar(@Kuvat^.GetItem(hTile05i)^.Data);
      'T': p := PChar(@Kuvat^.GetItem(hTile05j)^.Data);
      'U': p := PChar(@Kuvat^.GetItem(hTile05k)^.Data);
      'W': p := PChar(@Kuvat^.GetItem(hTile01 )^.Data);
      '?': p := PChar(@Kuvat^.GetItem(hTile04 )^.Data);
    End;

    w := Word(y)*320+ScreenX;

    If p=Nil
      Then FB[w] := #255
      Else FB[w] := p[Word(MapX)And 15 + (Word(y)And 15)Shl 4]
  End;
End;

Procedure LoadMap;
Var
  rx, ry,
  x, y: Integer;
Begin
  For y := 0 To High(Map)Do
    For x := 0 To High(Map[0])Do
    Begin
      rx := x*16 + 1;
      ry := y*16 + 16;
      Case Map[y, x]Of
        'e': ItsMe := World^.Insert(New(PExaMan, Init(rx, ry)));
        'f': World^.Insert(New(PFlyBoy, Init(rx, ry)));
      End
    End
End;

{---- MAIN PROGRAM ----}
Var
  x, y: Integer;
  f: File;
Label Lopeda;
Begin
  SwapInOut;

  RunErrorMessage := 'Runtime error %d at %04X:%04X. Sorry, no bonus :('^M^J;

  midasSetDefaults;

  HeapError := OutOfMemory;
  If SJmp(ErrorExit) <> 0 Then
    Goto Lopeda;

{$IFDEF NOSOUNDS}
  SoundError := 1;
{$ELSE}
  SoundError := midasInit;

  If SoundError <> 0 Then
  Begin
    Write('Sound system wants to notify you with the following error: '^M^J+
      '"',errorMsg[SoundError],'"'^M^J+
      'However, we will continue without sounds.'^M^J^J+
      'Press ENTER to continue...');
    ReadLn;
    WriteLn('Initializing...')
  End
  Else
  Begin
    SD := midasSD;                      { copy Sound Device pointer }
    midasOpenChannels(16); {8 musiikille, 8 efekteille}

{$IFNDEF NOMUSIC}
    module := midasLoadModule('mman2.mod',
      PModulePlayer(@mpMOD), NIL);
    midasPlayModule(module, 0);
{$ENDIF}
    eKZup00 := LoadEffect('kzup', 0);
  End;
{$ENDIF}
  GetMem(SB, 64000);
  GetMem(MB, 64000);
  GetMem(FB, 64000);
  GetMem(Result, 64000);

  LoadPCX('mega2.pcx', FB);

  New(Graph, Init);
  New(Kuvat, Init(100)); {Maksimissaan 100 kuvaa.}
  New(World, Init);

  hWalk00 := Kuvat^.Insert(43,0, 22,22);
  hWalk01 := Kuvat^.Insert(65,0, 24,22);
  hWalk02 := Kuvat^.Insert(89,0, 16,24);
  hJump00 := Kuvat^.Insert(1,24, 26,30);

  gJump00 := Kuvat^.Insert(27,24, 28,30);

  gWalk00 := Kuvat^.Insert(55,24, 30,22);
  gWalk01 := Kuvat^.Insert(85,24, 29,22);
  gWalk02 := Kuvat^.Insert(114,25, 26,24);

  hTile00 := Kuvat^.Insert(125,49, 16,16);
  hTile01 := Kuvat^.Insert(196,33, 16,16);
  hTile03 := Kuvat^.Insert(212,33, 16,16);
  hTile04 := Kuvat^.Insert(228,33, 16,16);

  hTile05a := Kuvat^.Insert(113,100, 16,16);
  hTile05b := Kuvat^.Insert(130,100, 16,16);
  hTile05c := Kuvat^.Insert(147,100, 16,16);
  hTile05d := Kuvat^.Insert(164,100, 16,16);
  hTile05e := Kuvat^.Insert(113,117, 16,16);
  hTile05f := Kuvat^.Insert(130,117, 16,16);
  hTile05g := Kuvat^.Insert(147,117, 16,16);
  hTile05h := Kuvat^.Insert(164,117, 16,16);
  hTile05i := Kuvat^.Insert(181,117, 16,16);
  hTile05j := Kuvat^.Insert(198,117, 16,16);
  hTile05k := Kuvat^.Insert(215,117, 16,16);

  oFlyBoy00 := Kuvat^.Insert(  0,55, 16,16);
  oFlyBoy01 := Kuvat^.Insert(109,49, 16,16);

  hUfo00 := Kuvat^.Insert(114,134, 20,6);

  LoadMap;

  Port[$3C8] := 0;
  For x := 0 To 767 Do Port[$3C9] := VGAPal[x]Shr 2;

  FillChar(SB^, 64000, 0);

  For x := 0 To 319 Do
  Begin
    MapRow(x, x);
    For y := 200 To 239 Do
      PSet(x, y, 0)
  End;

  KB_ON;
  Port[$3C2] := $E3;

  ItsMe^.Lock;
  While Not(KBuf[$54]Or KBuf[$01])And(World^.Items <> Nil)Do
  Begin
    RunStep;
    UpdateScreen;
  End;

  KB_ON;

  ItsMe^.UnLock;

  KB_OFF;

  Dispose(World, Done);
  Dispose(Kuvat, Done);
  Dispose(Graph, Done);

  MemW[Seg0040:$17] := 0;

Lopeda:
  If SoundError = 0 Then
  Begin
{$IFNDEF NOMUSIC}
    If module <> Nil Then
    Begin
      midasStopModule(module);
      midasFreeModule(module)
    End;
{$ENDIF}
    midasClose                          { uninitialize MIDAS }
  End;
  StdTerminator
End.
